#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASSetCallMemo : public CWASCommand
{
public:
	CWASSetCallMemo(CWASActor *pActor);
	~CWASSetCallMemo(void);

	void ExecuteAsync(void);

	void SetParameter(int nCallSeq, LPCWSTR strMemo)
	{
		m_nCallSeq = nCallSeq;
		m_strMemo = strMemo;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	int m_nCallSeq;
	WSTRING m_strMemo;
};
